package o3;
import java.util.*;

class StrList implements Iterable<String> {
  private static final int MAXLINE = 72;
  private static final String[] prot = {};
  ArrayList<String> list = new ArrayList<String>();
  String[] arr = null;
  public StrList() { }
  public StrList(String str) { this(); add(str); }
  public void add(String str) { list.add(str); }
  public void prepend(String str) { list.add(0, str); }
  public String[] getArray() {
    if(arr == null) { arr = list.toArray(prot); }
    return arr;
  }
  public String toString() {
    String[] a = getArray(); String s = a[0];
    for(int i = 1; i < a.length; ++i) { s += " " + a[i]; }
    return s;
  }
  public Iterator<String> iterator() {
    return list.iterator();
  }
  public void show(int i) {
    String s = nsp(i); int len = i; boolean nl = true;
    for(String t: getArray()) {
      if(!nl && len + t.length() > MAXLINE) {
        s += "\n" + nsp(i+2) + t; len = i+2+t.length(); nl = false;
      } else {
        s += " " + t; len += 1+t.length(); nl = false;
      }
    }
    System.out.println(s);
  }
  private static String nsp(int i) {
    String s = ""; while(s.length() < i) { s+=" "; } return s;
  }
}
