package o3;
import java.util.*;

public class TypeEquate {
  public static final int NONE=0, ANY=1, BOOL=2, INT=3, STRING=4, ARRAY=5;
  TypeEnv tenv;
  HashMap<String,Integer> map = new HashMap<String,Integer>();
  public TypeEquate(TypeEnv te) { tenv = te; }
  public void add(Tree.Para[] paras, int[] args) {
    if(paras.length != args.length) { return; }
    for(int i = 0; i < args.length; ++i) {
      map.put(paras[i].getName(), args[i]);
    }
  }
  public void add1(String n, int t) { map.put(n, t); }
  public int tname2tid(TypeName n) {
    TypeName[] a = n.getPara();
    if(a.length == 0 && map.containsKey(n.getIdn())) {
      return map.get(n.getIdn());
    } else if(a.length == 0) {
      return tenv.idn2tid(n.getIdn());
    }
    int[] tids = new int[a.length];
    for(int i = 0; i < a.length; ++i) {
      tids[i] = tname2tid(a[i]); if(tids[i] < 0) { return NONE; }
    }
    return tenv.idn2tgen(n.getIdn(), tids, n);
  }
  public void addSup(int i, int j) { tenv.addSup(i, j); }
  public String tid2cname(int tid) { return tenv.tid2cname(tid); }
  public String tid2sname(int tid) { return tenv.tid2sname(tid); }
  public Tbody.Base tid2tbody(int tid) { return tenv.tid2tbody(tid); }
  public int lookMproc(String s) { return tenv.lookMproc(s); }
//public Tbody.Clus tid2clu(int tid) {
//  Tbody.Base b = tenv.tid2tbody(tid);
//  if(b instanceof Tbody.Clus) { return (Tbody.Clus)b; }
//  return null;
//}
  public TypeEnv getTenv() { return tenv; }
  public String toString() {
    String s = "";
    for(String k: map.keySet()) { s += k+":"+map.get(k)+"; "; }
    return s;
  }
}
