package o3;
import java.util.*;

public class TypeName {
  public static TypeName UNDEF = new TypeName("undef");
  String idn, str;
  TypeName[] arr = {};
  public TypeName(String s) { idn = s; }
  public TypeName(String s, TypeName[] a) { idn = s; arr = a; }
  public String getIdn() { return idn; }
  public int getNpara() { return arr.length; }
  public TypeName[] getPara() { return arr; }
  public String toString() {
    if(str == null) {
      str = idn;
      if(arr.length > 0) {
        str += "[";
	for(int i = 0; i < arr.length; ++i) {
          if(i > 0) { str += ","; }
          str += arr[i].toString();
	}
	str += "]";
      }
    }
    return str;
  }
}
